#[derive(
    Debug,
    Clone,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct SnapshotRid(pub conjure_object::ResourceIdentifier);
impl std::fmt::Display for SnapshotRid {
    fn fmt(&self, fmt: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        std::fmt::Display::fmt(&self.0, fmt)
    }
}
impl conjure_object::Plain for SnapshotRid {
    fn fmt(&self, fmt: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        conjure_object::Plain::fmt(&self.0, fmt)
    }
}
impl conjure_object::FromPlain for SnapshotRid {
    type Err = <conjure_object::ResourceIdentifier as conjure_object::FromPlain>::Err;
    #[inline]
    fn from_plain(s: &str) -> Result<SnapshotRid, Self::Err> {
        conjure_object::FromPlain::from_plain(s).map(SnapshotRid)
    }
}
impl std::convert::From<conjure_object::ResourceIdentifier> for SnapshotRid {
    #[inline]
    fn from(v: conjure_object::ResourceIdentifier) -> Self {
        SnapshotRid(std::convert::From::from(v))
    }
}
impl std::ops::Deref for SnapshotRid {
    type Target = conjure_object::ResourceIdentifier;
    #[inline]
    fn deref(&self) -> &conjure_object::ResourceIdentifier {
        &self.0
    }
}
impl std::ops::DerefMut for SnapshotRid {
    #[inline]
    fn deref_mut(&mut self) -> &mut conjure_object::ResourceIdentifier {
        &mut self.0
    }
}
impl std::convert::AsRef<conjure_object::ResourceIdentifier> for SnapshotRid {
    #[inline]
    fn as_ref(&self) -> &conjure_object::ResourceIdentifier {
        &self.0
    }
}
